
#include "planche.h"
#include "conteneur.h"

conteneur::conteneur()
{

 setFocusPolicy(QWidget::StrongFocus) ;

 _scrollview = new QScrollView( this ) ;
 _scrollview->setGeometry(0,0,width(),height()) ;
 _planche = new planche() ;
 _scrollview->addChild( _planche ) ;

 // c'est galre
 QObject::connect( this,SIGNAL(signalRestart(int,bool)),_planche,SLOT(slotRestart(int,bool))) ;
 QObject::connect( this,SIGNAL(signalRandom(int,bool)),_planche,SLOT(slotRandom(int,bool))) ;
 QObject::connect( this,SIGNAL(signalCalculate()),_planche,SLOT(slotCalculate())) ;
 QObject::connect( this,SIGNAL(signalSaveImage()),_planche,SLOT(slotSaveImage())) ;
 QObject::connect( this,SIGNAL(signalBugChanged(bool)),_planche,SLOT(slotBugChanged(bool)) ) ;
 QObject::connect( this,SIGNAL(signalSizeChanged(int)),_planche,SLOT(slotSizeChanged(int)) ) ;
 QObject::connect( this,SIGNAL(signalLoadAppli(int*,int,int )),_planche,SLOT(slotLoadAppli(int*,int,int )) ) ;
}

/*
 *  Destroys the object and frees any allocated resources
 */
conteneur :: ~conteneur()
{
  delete _planche ;
}

void conteneur :: slotCalculate() { emit signalCalculate() ; }
void conteneur :: slotSaveImage() { emit signalSaveImage() ; }
void conteneur :: slotRestart(int a,bool b ) { emit signalRestart( a,b ) ; }
void conteneur :: slotRandom(int a,bool b) { emit signalRandom(a,b) ; }
void conteneur :: slotBugChanged(bool a) { emit signalBugChanged(a) ; }
void conteneur :: slotSizeChanged(int a) { emit signalSizeChanged(a) ; }
void conteneur :: slotLoadAppli(int* a,int b,int c) { emit signalLoadAppli(a,b,c) ; }


void conteneur :: keyPressEvent( QKeyEvent* event )
{
 int rep ;

 rep = event->key() ;

 if (rep == Qt::Key_Space )
	{
	 //cout << "\n Arhhhhhhhhhhhhh !!!!!!";
	 emit signalCalculate() ;
	}
 if (rep == Qt::Key_S )
	{
	 emit signalSaveImage() ;
	}

}

void conteneur :: resizeEvent(QResizeEvent* e )
{
 _scrollview->setGeometry(0,0,width(),height()) ;
}





