
#ifndef planche_H
#define planche_H

using namespace std ;

#include <iostream>
#include <cmath>


#include <qpainter.h>
#include <qpixmap.h>
#include <qwidget.h>
#include <qprogressdialog.h>

#define SIZE_X 2053
#define SIZE_Y 512
#define SPEED 25

class planche : public QWidget
{
   Q_OBJECT

 public :
  planche() ;  // constructeur
  ~planche() ;

 protected :
  virtual void keyPressEvent( QKeyEvent*  ) ;
  virtual void paintEvent( QPaintEvent* ) ;
  virtual void closeEvent( QCloseEvent* ) ;
  //virtual void resizeEvent( QResizeEvent* ) ;

 private :
  void initialisePlancheProgress( int pour, bool withoutBug ) ;
  void initialisePlanche( int pour, bool withoutBug ) ;
  void calculate() ;

 private slots :
  void slotCalculate() ;
  void slotSaveImage() ;
  void slotRestart(int,bool ) ;
  void slotRandom(int nbVoisinsNew ,bool symm ) ;
  void slotBugChanged( bool ) ;
  void slotSizeChanged(int) ;
  void slotLoadAppli(int*,int,int ) ;

 private :
  QPixmap _buffer ;
  QProgressDialog* _progressD ;
  int* appli ;
  int* old ;
  int* current ;
  int nbVoisins ;
  bool withoutBug ;
  int sizeX, sizeY ;
  //Parametres* _parametre ;

} ;

#endif
